var Itemtrace = (function ($) {
    var formID = "ItemTraceForm";
    var itemCode = "";
    var afterModal = 0;
    var codeImageVerification = "";//need cookie ?
    var hazmana = 0;

    $(document).ready(function () {
        init();
    });

    function init() {
        try {
            initValidation();
            initEvent();
            $("#ItemCode").focus();
            itemCode = getURLParameter("itemcode");
            if (itemCode != undefined && itemCode != null && itemCode != "") {
                $("#ItemCode").val(itemCode);
                $("#btn-ItemCode").click();
            }
        }
        catch (err) { dispError("init: " + err) }
    }

    function initValidation() {
        try {
            $('#ItemTraceForm').keydown(function (e) {
                if (e.keyCode == 13) {//Enter
                    disableEventPropagation(e);
                    e.preventDefault();
                    searchItem();
                    return false;
                }
            });
            $('#CodeVerificationInput').keydown(function (e) {
                if (e.keyCode == 13) {//Enter
                    disableEventPropagation(e);
                    $("#setCode").click();
                    return false;
                }
            });


            jQuery.validator.addMethod("itemformat", function (value, element) {
                return ((value.length == 8 || value.length == 13)) && /^['\- a-z0-9]*$/gim.test(value);
            }, "bad format");
            $("#" + formID).validate({
                rules: {
                    ItemCode: {
                        required: true,
                        itemformat: true
                    },
                    PwdCode: {
                        required: true
                    }
                },
                messages: {
                    ItemCode: {
                        required: $("#ItemCode").attr("data_msg_required"),
                        itemformat: $("#ItemCode").attr("data-msg-badformat")
                    },
                    PwdCode: { required: $("#CodeVerificationInput").attr("data-msg-pagerequired") }
                }
            });
        } catch (err) { dispError("initValidation: " + err) }
        return false;
    }
    function initEvent() {
        try {

            $('#btn-ItemCode').on('click', function () {
                searchItem(); return false;
            });
            $('#btn-Print').on('click', function () {
                myPrint(); return false;
            });
            $('#btn-GetImage').on('click', function () {
                getImage(); return false;
            });
            $('#btn-GetSignature').on('click', function () {
                getSignature(); return false;
            });
            $('#btn-GetFile').on('click', function () {
                getFile(); return false;
            });

            $("#cancelBtn").click(function () {
                afterModal = 0;
                codeImageVerification = "";
                $("#CodeVerificationInput").val("");
                $("#askVerificationImage").modal("hide");
            })
            $("#setCode").click(function () {
                if ($("#" + formID).valid()) {
                    continueAfterModal();
                }
                return false;
            })
            $('#askVerificationImage').on('shown.bs.modal', function () {
                $('#CodeVerificationInput').focus();
            })
        } catch (err) { dispError("initValidation: " + err) }
    }
    function searchItem() {//btn-ItemCode call this
        try {

            if (!$("#" + formID).valid()) {
                return false;
            }
            itemCode = $('#ItemCode').val();
            JsLibrary.ShowLoader(lang == 'en');

            var callGetItemTrace = $.ajax({
                url: urlCallGetItemTrace,
                type: 'POST',
                data: { "itemCode": itemCode, "lcid": lcid, __RequestVerificationToken: $('[name=__RequestVerificationToken]').val() }
            })
            .done(handleResponseGetItemTrace)
            .fail(function () { return (dispError(urlCallGetItemTrace)) });
            return false;
        }
        catch (err) { dispError("searchItem: " + err) }
        return false;
    }


    function handleResponseGetItemTrace(data)/* , textStatus, jqXHR )*/ {
        try {
            JsLibrary.HideLoader();
            $("#result").show();

            cleanResult();
            if (!data || data.ReturnCode == 9) {
                $("#dyntable").text(NetworkError);
                return false;
            }
            if (!data || data.ReturnCode == 11) {
                $("#dyntable").text(BadBarcodeError);
                return false;
            }
            if (data.ReturnCode != 0) {
                $("#dyntable").text(GeneralError);
                return false;
            }
            $("#printDiv").show();

            if (data.Result.sHeader1 && data.Result.sHeader1 != undefined) {
                if (data.Result.sHeader1.toLowerCase().indexOf(data.Result.Barcode.toLowerCase()) == -1) {
                    $("#barcodetitle").text(data.Result.sHeader1 + " " + data.Result.Barcode);
                } else {
                    $("#barcodetitle").text(data.Result.sHeader1);
                }
            }
            else {
                var tntmp = data.Result.typeName;
                if (tntmp == null || tntmp == undefined) tntmp = "";
                $("#barcodetitle").html("<span>" + label_barcodetitle + " " + tntmp + "</span>: <span>" + data.Result.Barcode + "</span>");
            }
            if (data.Result.sHeader2 && data.Result.sHeader2 != undefined) {
                var origBC = JsLibrary.Fulltrim(data.Result.sHeader2.substring(0, data.Result.sHeader2.indexOf("(")));

                var addLang = "";
                if (data.Result.Lang && data.Result.Lang.toLowerCase() != "he") {
                    addLang = "lang=" + data.Result.Lang + "&";
                }
                $("#barcodebottom").html("<br/><a href='?" + addLang + "itemcode=" + origBC + "' class='MoreU'>" + data.Result.sHeader2 + "</a>");
            }
            if (data.Result.hasImage) {
                $("#getImageDiv").show();
            }
            if (data.Result.hasSignImage) {
                $("#getSignDiv").show();
            }
            if (data.Result.hazmana != undefined && data.Result.hazmana != 0) {
                hazmana = data.Result.hazmana;
                $("#getFile").show();
            }
            renderResult(data.Result.itemcodeinfo);

        } catch (err) { }
        return false;
    }
    function renderResult(itemcodeinfo) {
        try {
            if (!itemcodeinfo || !itemcodeinfo.ColumnHeaders || !itemcodeinfo.InfoLines) {
                $("#dyntable").text = NetworkError;
                return false;
            }
            else {
                $("#dyntable").text = "";//clean
            }
            var nbCol = itemcodeinfo.ColCount;
            var dyntable = "";
            if (itemcodeinfo.ColumnHeaders.length > 0) {
                dyntable += "<div class=\"row align-middle dyntab-header hidden-mobile\">";
                for (var i = 0, len = itemcodeinfo.ColumnHeaders.length; i < len; i++) {
                    dyntable += builtColBootstrap(nbCol, 0, i) + itemcodeinfo.ColumnHeaders[i] + "</div>";
                }
                dyntable += "</div>";//end line header
            }

            if (itemcodeinfo.InfoLines.length >= 0) {

                for (var y = 0, leny = itemcodeinfo.InfoLines.length; y < leny; y++) {
                    colOfLine = itemcodeinfo.InfoLines[y];

                    if (colOfLine.length > 0) {
                        dyntable += "<div class=\"row borderUp\">";
                        "<div class=\"col-md-3 col-xs-12 R align-middle grey-header\">";
                        for (var i = 0, len = colOfLine.length; i < len; i++) {
                            if (i == 0) {
                                dyntable += builtColBootstrap(colOfLine.length, 2, i) + renderHour(colOfLine[i]) + "</div>";
                            } else {
                                dyntable += builtColBootstrap(colOfLine.length, 2, i) + colOfLine[i] + "</div>";
                            }
                        }
                        dyntable += "</div>";//end line 
                    }
                }

            }
            $("#dyntable").html(dyntable);
        } catch (err) { dispError("renderResult: " + err) }
    }

    function builtColBootstrap(nbCol, area, col) {
        // nbCol:1 based (2 col = 2col), area:0 header, col:0 based (0=1st col, 1=2nd col)
        var colBootstrap = "";
        try {
            if (area == 0) {
                if (nbCol == 2) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-4 col-xs-12 dyntab-firstCol R\" role=\"rowheader\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-8 col-xs-12 R\" role=\"rowheader\">";
                    }
                } else if (nbCol == 3) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 dyntab-firstCol R\" role=\"rowheader\">";
                    } else if (col == 1) {
                        colBootstrap = "<div class=\"col-md-5 col-xs-12 R\" role=\"rowheader\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-4 col-xs-12 R\" role=\"rowheader\">";
                    }
                } else if (nbCol == 4) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 dyntab-firstCol R\" role=\"rowheader\">";
                    } else if (col == 1) {
                        colBootstrap = "<div class=\"col-md-4  col-xs-12 R\" role=\"rowheader\">";
                    } else if (col == 3) {
                        colBootstrap = "<div class=\"col-md-2 col-xs-12 R\" role=\"rowheader\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 R\" role=\"rowheader\">";
                    }
                } else {
                    colBootstrap = "<div class=\"dynatab-onlyone\">";
                }

            } else {//not area 0, ie not header
                if (nbCol == 2) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-4 col-xs-12 R dyntab-firstCol\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-8 col-xs-12 R\">";
                    }
                } else if (nbCol == 3) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 dyntab-firstCol R\">";
                    } else if (col == 1) {
                        colBootstrap = "<div class=\"col-md-5 col-xs-12 R\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-4 col-xs-12 R\">";
                        colBootstrap += "<i class=\"fa fa-map-marker fa-fw only-mobile dimgrey\" aria-hidden=\"true\"></i> ";
                    }
                } else if (nbCol == 4) {
                    if (col == 0) {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 dyntab-firstCol R\">";
                    } else if (col == 1) {
                        colBootstrap = "<div class=\"col-md-4  col-xs-12 R\">";
                    } else if (col == 3) {
                        colBootstrap = "<div class=\"col-md-2 col-xs-12 R\">";
                    } else {
                        colBootstrap = "<div class=\"col-md-3 col-xs-12 R\">";
                    }

                    if (col == 3) {
                        colBootstrap += "<i class=\"fa fa-home fa-fw only-mobile dimgrey\" aria-hidden=\"true\"></i> ";
                    } else if (col == 2) {
                        colBootstrap += "<i class=\"fa fa-map-marker fa-fw only-mobile dimgrey\" aria-hidden=\"true\"></i> ";
                    }
                } else {
                    colBootstrap = "<div class=\"dynatab-onlyone\">";
                }
            }
        } catch (err) {
            dispError("builtColBootstrap: " + err)
        }
        return colBootstrap;
    }
    function renderHour(datetime) {
        try {
            if (window.matchMedia('(min-width: 768px)').matches) {
                var posSpace = datetime.indexOf(" ")
                if (posSpace != -1) {
                    var onlyDateStr = datetime.substring(0, posSpace);
                    var onlyDate = onlyDateStr.split("/");
                    if (onlyDate.length == 1) onlyDate = onlyDateStr.split(".");
                    if (onlyDate.length == 1) onlyDate = onlyDateStr.split("-");
                    if (onlyDate.length == 3) {
                        var realDate = new Date(onlyDate[2], onlyDate[1] - 1, onlyDate[0]);
                        if (realDate instanceof Date && !isNaN(realDate.valueOf()))
                            return datetime.replace(" ", "<br>");
                    }
                }
            }
        } catch (err) { }
        //all other case:
        return datetime;
    }

    function cleanResult() {
        try {
            $("#printDiv").hide();
            $("#barcodetitle").text("");
            $("#barcodebottom").text("");
            $("#getImageDiv").hide();
            $("#saveImageDiv").hide();
            $("#getSignDiv").hide();
            $("#ImageDiv").text("");
            $("#SignatureDiv").text("");
            $("#saveSignatureDiv").hide();
            $("#getFile").hide();
            $("#FileDiv").text("");
            $("#ItemImageError").text("");

            return false;
        } catch (err) {
            dispError("cleanResult: " + err)
        }
        return str;
    }
 
    function getURLParameter(name) {
        try {
            return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search) || [null, ''])[1].replace(/\+/g, '%20')) || null;
        } catch (err) {
            dispError("getURLParameter: " + name)
        }
    }
    function dispError(data) { //this is the default error function for Ajax
        try {
            JsLibrary.HideLoader();
            try { $("#askVerificationImage").modal("hide"); } catch (err) { }//if it was in modal

            console.log("there was an error : " + JSON.stringify(data));
        } catch (err) { }
        return false;
    }
    function disableEventPropagation(event) {
        try {
            if (event.preventDefault) {
                event.preventDefault();
            }
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            else if (window.event) {
                window.event.cancelBubble = true;
            }
        } catch (err) {
        }
    }
    function myPrint() {
        try {
            window.print();
        } catch (err) { }
    }
    function detectChrome() {
        var isChromium = window.chrome,
    winNav = window.navigator,
    vendorName = winNav.vendor,
    isOpera = winNav.userAgent.indexOf("OPR") > -1,
    isIEedge = winNav.userAgent.indexOf("Edge") > -1,
    isIOSChrome = winNav.userAgent.match("CriOS");

        if (isIOSChrome) {
            return true;
        } else if (
          isChromium !== null &&
          typeof isChromium !== "undefined" &&
          vendorName === "Google Inc." &&
          isOpera === false &&
          isIEedge === false
        ) {
            return true;
        } else {
            return false;
        }
    }
    function getImage() {
        try {
            if (codeImageVerification == "") {
                afterModal = 1;
                $("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }

            $('#PwdCode-error').text('');
            $("#ImageDiv").text("");
            $("#ImageDiv").html("");

            JsLibrary.ShowLoader(lang == 'en');

            var captcharesponse = grecaptcha.getResponse();

            var callGetItemTrace = $.ajax({
                url: urlCallGetImage,
                type: 'POST',
                data: {
                    "itemCode": itemCode,
                    "imageVerification": codeImageVerification,
                    "lcid": lcid,
                    "captchaResponse":captcharesponse,
                    __RequestVerificationToken: $('[name=__RequestVerificationToken]').val()
                }
            })
            .done(handleResponsegetImage)
            .fail(function () { dispError(urlCallGetImage) });

        } catch (err) {
            dispError("getImage: " + err)
        }
    }
    function handleResponsegetImage(data, mydiv)/* , textStatus, jqXHR )*/ {
        mydiv = (typeof mydiv === 'undefined' || mydiv == "success") ? "#ImageDiv" : mydiv;
        $('#captcha-error').text('');
        grecaptcha.reset();

        try {

            JsLibrary.HideLoader();
            //if bad code then codeImageVerification="" and getImage() ?
            if (!data || data.ReturnCode == undefined) {
                $("#ItemImageError").text(NetworkError);
                $('#PwdCode-error').text(NetworkError);
                $("#askVerificationImage").modal("hide");
                return false;
            }

            if (data.ShowCaptcha || data.ReturnCode==23)
                $('#captcha').removeClass('hidden');
            else {
                $('#captcha').addClass('hidden');
            }

            if (data.ReturnCode ==20) {
                $('#captcha-error').text(data.ErrorDescription);
                codeImageVerification = ""; //to force re ask
                afterModal = 1;
                //$("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }

            if (data.ReturnCode == 21) {
                $('#captcha-error').text(data.ErrorDescription);
                codeImageVerification = ""; //to force re ask
                afterModal = 1;
               // $("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }

            if (data.ReturnCode == 16 || data.ReturnCode == 17 || data.ReturnCode == 18) {
                $("#ItemImageError").text(data.ErrorDescription);
                $('#PwdCode-error').text(data.ErrorDescription);
                codeImageVerification = ""; //to force re ask
                $("#CodeVerificationInput").val("");
                if (data.ReturnCode == 18) {
                    afterModal = 1;
                    $("#askVerificationImage").modal("show");
                    $("#CodeVerificationInput").focus();
                }
                return false;
            }
            if (data.ReturnCode != 0) {
                $("#ItemImageError").text(GeneralError);
                $('#PwdCode-error').text(GeneralError);
                codeImageVerification = ""; //to force re ask
                afterModal = 1;
                //$("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }
            $("#askVerificationImage").modal("hide");
            if (!data.ImageBase64) {
                $("#ItemImageError").text(GetImageError);
               
                return false;
            }

            $("#ItemImageError").text("");
            $(mydiv).html("<img id='certifImg' src='data:image/jpeg;base64, " + data.ImageBase64 + "'/>");
            $(mydiv).focus();

            if (detectChrome()) {
                $("#save" + mydiv.substring(1)).show();
                var link;
                if (mydiv == "#SignatureDiv")
                    link = document.getElementById("link-SaveSignature");
                else // default
                    link = document.getElementById("link-SaveImage");
                if (link) {
                    link.setAttribute("href", 'data:image/octet-stream;base64, ' + data.ImageBase64);
                    link.download = data.ImageFilename;
                }
            }
        } catch (err) {
            $("#ItemImageError").append(GetImageError);
            $("#askVerificationImage").modal("hide");
        }
        return false;
    }
    function handleResponsegetSignature(data) {
        try {
            JsLibrary.HideLoader();
            handleResponsegetImage(data, "#SignatureDiv");
        } catch (err) {
            $("#ItemImageError").append(GetImageError);
        }
        return false;
    }

    function getSignature() {
        try {
            if (codeImageVerification == "") {
                afterModal = 2;
                $("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }
            $('#PwdCode-error').text('');
            $("#SignatureDiv").html("")
            var captcharesponse = grecaptcha.getResponse();
            JsLibrary.ShowLoader(lang == 'en');
            var callGetSignature = $.ajax({
                url: urlCallGetSignature,
                type: 'POST',
                data: {
                    "itemCode": itemCode,
                    "imageVerification": codeImageVerification,
                    "captchaResponse": captcharesponse,
                    "lcid": lcid,
                    __RequestVerificationToken: $('[name=__RequestVerificationToken]').val()
                }
            })
            .done(handleResponsegetSignature)
            .fail(function () { dispError(urlCallGetSignature) });

        } catch (err) {
            $("#ItemImageError").append(GetImageError);
        }
    }
    function getFile() {
        try {
            if (hazmana == 0) {
                return false;
            }


            var captcharesponse = grecaptcha.getResponse();
            $('#PwdCode-error').text('');
            JsLibrary.ShowLoader(lang == 'en');
            var callGetFile = $.ajax({
                url: urlCallGetFile,
                type: 'POST',
                data: {
                    "itemCode": itemCode,
                    "Hazmana": hazmana,
                    "captchaResponse": captcharesponse,
                    "lcid": lcid,
                    __RequestVerificationToken: $('[name=__RequestVerificationToken]').val()
                }
            })
            .done(handleResponsegetFile)
            .fail(function () { dispError(urlCallGetFile) });

        } catch (err) {
            $("#ItemImageError").append(GetImageError);
        }
    }
    function handleResponsegetFile(data)/* , textStatus, jqXHR )*/ {
        try {
            var mydiv = "#ItemImageError";
            grecaptcha.reset();

            JsLibrary.HideLoader();

            if (!data || data.ReturnCode == undefined) {
                $("#ItemImageError").text(NetworkError);
                $('#PwdCode-error').text(NetworkError);
                return false;
            }

            if (data.ShowCaptcha || data.ReturnCode == 23)
                $('#captcha').removeClass('hidden');
            else {
                $('#captcha').addClass('hidden');
            }

            if (data.ReturnCode == 20) {
                $('#captcha-error').text(data.ErrorDescription);
                codeImageVerification = ""; //to force re ask
                afterModal = 1;
                $("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }

            if (data.ReturnCode == 21) {
                $('#captcha-error').text(data.ErrorDescription);
                codeImageVerification = ""; //to force re ask
                afterModal = 1;
                $("#askVerificationImage").modal("show");
                $("#CodeVerificationInput").focus();
                return false;
            }

            if (data.ReturnCode == 18 || data.ReturnCode == 16 || data.ReturnCode == 17) {
                $("#ItemImageError").text(data.ErrorDescription);
                $('#PwdCode-error').text(data.ErrorDescription);
                if (data.ReturnCode == 18) {
                    afterModal = 1;
                    $("#askVerificationImage").modal("show");
                    $("#CodeVerificationInput").focus();
                }
                return false;
            }
            if (data.ReturnCode != 0) {
                $("#ItemImageError").append(GeneralError);
                $('#PwdCode-error').text(GeneralError);
                return false;
            }

            if (!data.ImageBase64) {
                $("#ItemImageError").append(GetImageError);//update to no file ?
                $('#PwdCode-error').text(GeneralError);
                return false;
            }

            var data = data.ImageBase64;
            var fileName = data.ImageFilename;
            $("#ItemImageError").text("");
            if (window.navigator && window.navigator.msSaveOrOpenBlob) { // IE workaround
                var byteCharacters = atob(data);
                var byteNumbers = new Array(byteCharacters.length);
                for (var i = 0; i < byteCharacters.length; i++) {
                    byteNumbers[i] = byteCharacters.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                var blob = new Blob([byteArray], { type: 'application/pdf' });
                window.navigator.msSaveOrOpenBlob(blob, fileName);
            }
            else { // not IE
                //window.open("data:application/pdf;base64, " + data, '', "height=600,width=800"); this no more work !
                var pdfWindow = window.open("");
                pdfWindow.document.write("<iframe width='100%' height='100%' src='data:application/pdf;base64, " + data + "'></iframe>");
            }
        } catch (err) {
            $("#ItemImageError").append(GetImageError);
            $('#PwdCode-error').text(GeneralError);
        }
        return false;
    }

    function continueAfterModal() {
        try {
            codeImageVerification = $("#CodeVerificationInput").val();
            if (codeImageVerification == "") {
                alert($("#CodeVerificationInput").attr("data-msg-pagerequired"));
                return false
            }

           // $("#askVerificationImage").modal("hide");
            if (afterModal == undefined || afterModal == 0)
                return false;
            if (afterModal == 1)
                getImage();
            else if (afterModal == 2)
                getSignature();
            else if (afterModal == 3)//not in use
                getFile();
            else
                dispError("unknown afterModal=" + afterModal);
        } catch (err) {
            dispError("getSignature: " + err)
        }
        return false;
    }
    //Next are the public methods
    return {
        Init: init,
        SearchItem: searchItem,
        GetImage: getImage,
        GetSignature: getSignature,
        GetFile: getFile
    };
})(jQuery);

